<?php

define('TIMEOUT', 20);

$command = trim($argv[1]);

$cmd_id = substr($command,0,40);
if($cmd_id != $command) $cmd_id .= "...";

$n = (int)`ps -C gp|wc -l` - 1;

if($n >= 2)
{
  echo "Too many .cc processes running, .cc request '$cmd_id' ignored\n";
  exit;
}

$pipes = Array();
$fp = proc_open(
  'LD_PRELOAD=/home/bisqbot/paranoid.so gp -q -f',
  Array(0=>Array('pipe','r'),
        1=>Array('pipe','w'),
        2=>Array('pipe','w')),
  $pipes);

fwrite($pipes[0], "$command;\n\\a\n");
fclose($pipes[0]);

$stdout = '';
$stderr = '';
$problem = false;
$eof = 0;
while($eof < 2)
{
  $read  = Array($pipes[1], $pipes[2]);
  
  $ret = stream_select($read, $write=NULL, $except=NULL, TIMEOUT);
  if(!$ret)
  {
    $problem = true;
    break;
  }
  
  foreach($read as &$stream)
  {
    $dummy = '';
    $target = &$dummy;
    if($stream == $pipes[1]) $target = &$stdout;
    elseif($stream == $pipes[2]) $target = &$stderr;
    
    $data = fread($stream, 8192);
    $target .= $data;
    if(strlen($data) == 0) ++$eof;
  }
}

if($problem)
{
  echo "The .cc request '$cmd_id' takes too long to calculate. Terminated.\n";
  $status = proc_get_status($fp);
  posix_kill($status['pid'], 15);
  proc_close($fp);
  exit;
}

if(!empty($stderr))
{
  $msg = trim($stderr);
  $msg = ereg_replace('^[ *]*', '', $msg);
  $msg = ereg_replace("[\n].*", '', $msg);
  
  echo "Error in .cc request '$cmd_id'. Explanation: \"$msg\"\n";
}
else
{
  $msg = trim($stdout);
  if(ereg("\n", $msg))
    echo "Error in .cc request '$cmd_id'. It outputs more than one line.\n";
  else
  {
    $msg = str_replace(';', '; ', $msg);
    $msg2 = '';
    if(strlen($msg) > 200)
    {
      $chop = strlen($msg)-180;
      $msg2 = " ($chop characters chopped)";
      $msg = substr($msg, 0, 180);
    }
    echo "result = '$msg'$msg2\n";
  }
}
proc_close($fp);
